/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bussiness.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.common.constant.SystemConstant;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.guosen.billRecord.entity.BillRecord;
import org.springblade.modules.guosen.bussiness.entity.Bussiness;
import org.springblade.modules.guosen.bussiness.service.IBussinessService;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bussiness.entity.BussinessDebit;
import org.springblade.modules.guosen.bussiness.vo.BussinessDebitVO;
import org.springblade.modules.guosen.bussiness.service.IBussinessDebitService;
import org.springblade.core.boot.ctrl.BladeController;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-07-20
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-guosen/bussinessdebit")
@Api(value = "", tags = "接口")
public class BussinessDebitController extends BladeController {

	private final IBussinessDebitService bussinessDebitService;
	private final IBussinessService bussinessService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bussinessDebit")
	public R<BussinessDebit> detail(BussinessDebit bussinessDebit) {
		BussinessDebit detail = bussinessDebitService.getOne(Condition.getQueryWrapper(bussinessDebit));
		return R.data(detail);
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bussinessDebit")
	public R<IPage<BussinessDebit>> list(BussinessDebit bussinessDebit, Query query) {
		BladeUser user = AuthUtil.getUser();
		Bussiness bussiness = bussinessService.getBaseMapper().selectOne(new QueryWrapper<>(new Bussiness()).lambda()
			.eq(Bussiness::getAccountId, user.getUserId()));
		if(bussiness != null){
			bussinessDebit.setBussinessId(bussiness.getId());
		}
		Date createTime = bussinessDebit.getCreateTime();
		String createTimeFormat = null;
		if(createTime != null){
			bussinessDebit.setCreateTime(null);
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
			createTimeFormat = sdf.format(createTime);
		}
		LambdaQueryWrapper<BussinessDebit> lambda = Condition.getQueryWrapper(bussinessDebit).lambda();
		lambda.like(createTime != null, BussinessDebit::getCreateTime, createTimeFormat);
		IPage<BussinessDebit> pages = bussinessDebitService.page(Condition.getPage(query), lambda.orderByDesc(BussinessDebit::getUpdateTime));
		return R.data(pages);
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bussinessDebit")
	public R<IPage<BussinessDebitVO>> page(BussinessDebitVO bussinessDebit, Query query) {
		IPage<BussinessDebitVO> pages = bussinessDebitService.selectBussinessDebitPage(Condition.getPage(query), bussinessDebit);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bussinessDebit")
	public R save(@Valid @RequestBody BussinessDebit bussinessDebit) {
		return R.status(bussinessDebitService.save(bussinessDebit));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bussinessDebit")
	public R update(@Valid @RequestBody BussinessDebit bussinessDebit) {
		return R.status(bussinessDebitService.updateById(bussinessDebit));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bussinessDebit")
	public R submit(@Valid @RequestBody BussinessDebit bussinessDebit) {
		return R.status(bussinessDebitService.saveOrUpdate(bussinessDebit));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(bussinessDebitService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/debitStat")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分润统计", notes = "传入bussinessDebit")
	public R<BigDecimal> debitStat(BussinessDebit bussinessDebit) {
		BigDecimal debitStat = bussinessDebitService.debitStat(bussinessDebit);
		return R.data(debitStat);
	}


}
